package pl.webnet.JaTrac;

import java.awt.*;

class CheckerColorMap extends Texture
{
	Spectrum c0, c1;
	int repeatU, repeatV;

	public CheckerColorMap()
	{
		super();
	}

	public CheckerColorMap(Spectrum c0, Spectrum c1)
	{
		this.c0 = c0.create(c0);
		this.c1 = c1.create(c1);
	}

	public Spectrum updateSpectrum(Spectrum s, Point uv)
	{
		double r, g, b;
		double[] c;
		int u = (int)(Math.round(uv.x * repeatU));
		int v = (int)(Math.round(uv.y * repeatV));

		if(((u ^ v) & 1) == 0)
			c = c0.getRGB(null);
		else
			c = c1.getRGB(null);

		
		return s.create(c[0], c[1], c[2]);
	}

	public String[] getParamArray()
	{
		final String params[] = {
			"name", "name", "",
			"repeatU", "repeatU", "",
			"repeatV", "repeatV", "",
			"spectrum0", "c0", "",
			"spectrum1", "c1", ""
		};

		return params;
	}
	
	public String[] getAttachArray() { return null; }

	public Object initialize()
	{
		return this;
	}

	public int getProperties()
	{
		return TEXTURE_SPECTRUM;
	}

}
