package pl.webnet.JaTrac;

import javax.imageio.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.io.*;

class DiskImageIO
{
	int width = -1, height = - 1;
	boolean imgReady = false;
	int pixels[];

	public DiskImageIO(String filename)
	{
		PixelGrabber pGrabber;
		BufferedImage img = null;
		
		try
		{
			URL fileURL = makeAbsoluteURL(filename);
			img = ImageIO.read(fileURL);

			System.out.println("Loading image: " + fileURL);

			width = img.getWidth();
			height = img.getHeight();

			System.out.println("Size: " + width + "x" + height);

		} catch(Exception e)
		{ e.printStackTrace(); }

		pGrabber = new PixelGrabber(img, 0, 0, width, height, true);

		try {
//			System.out.println("Converting to internal representation...");
			pGrabber.grabPixels();
		} catch (InterruptedException e)
		{ e.printStackTrace(); }

		pixels = (int [])pGrabber.getPixels();
	}

	static public URL makeAbsoluteURL (String url) throws MalformedURLException
	{
		URL baseURL;

		String currentDirectory = System.getProperty("user.dir");

		String fileSep = System.getProperty("file.separator");
		String file = currentDirectory.replace(fileSep.charAt(0), '/') + '/';

		if (file.charAt(0) != '/') {
			file = "/" + file;
		}

		baseURL = new URL("file", null, file);
			return new URL(baseURL,url);
	}

}

