package pl.webnet.JaTrac;

import java.util.*;
import java.io.*;

/**
 * This plugin loads data from Integra file format doing conversion
 * on the fly.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: $Id: IntegraPlugin.java,v 1.2 2001/05/31 14:41:39 thorgal Exp $
 */

class IntegraPlugin implements XmlSettable
{
	String filePath;

	public IntegraPlugin()
	{
	}

	public String[] getParamArray()
	{
		String params[] = {
			"filepath", "filePath", ""
		};

		return params;
	}

	public String[] getAttachArray()
	{
		String params[] = {
		};

		return params;
	}

	public Object initialize()
	{
		IntegraLexer lex;

		try
		{
			System.out.println("Attempting parsing of camera file");
			lex = new IntegraLexer(new FileInputStream(filePath + "/atrium.cam"));
			do
			{ } while(lex.yylex() != -1);


			System.out.println("Attempting parsing of shape file");
			lex = new IntegraLexer(new FileInputStream(filePath + ".shp"));

			do
			{ } while(lex.yylex() != -1);

			System.out.println("Attempting parsing of attribute file");
			lex = new IntegraLexer(new FileInputStream(filePath + "/atrium.atr"));

			do
			{ } while(lex.yylex() != -1);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		return this;
	}

}
