package pl.webnet.JaTrac;

//import com.microstar.xml.XmlHandler;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import java.net.*;
import java.util.*;


public class Loader extends DefaultHandler
{
	Stack objectStack = new Stack();
	Class thisclass = null;
	Object current = null;
	static Scene scene;
	

	public Loader()
	{
	}

	public Scene load(String name)
	{
		DefaultHandler handler = new Loader();

		SAXParserFactory factory = SAXParserFactory.newInstance();
		factory.setNamespaceAware(true);
//		factory.setValidating(true);


		try {
			SAXParser saxParser = factory.newSAXParser();

			URL fileURL = DiskImageIO.makeAbsoluteURL(name);
			//saxParser.parse("file://" + name, handler);
			saxParser.parse(fileURL.toString(), handler);
		} catch (Exception e) { e.printStackTrace(); }

		return scene;
	}

	public void startElement(String namespaceURI,
		String sName, // simple name (localName)
		String qName, // qualified name
		Attributes attrs)
  throws SAXException
	{
//		System.out.println("1: " + namespaceURI + " 2: " + sName + " 3: " + qName);
		String el = qName;

//		System.out.println("startElement: " + el);

		try {
			objectStack.push(current);
			thisclass = Class.forName("pl.webnet.JaTrac." + el);

			Object prev = current;
			current = thisclass.newInstance();

			if(current instanceof Scene)
				scene = (Scene)current;

			// if we just instantiated a TreeNode, check if its parent is also
			// a TreeNode and set child - parent references.
			if(current instanceof TreeNode)
				if(prev instanceof Level)
					((TreeNode)current).setParent((Level)prev);
				else
					((TreeNode)current).setParent((Level)null);

			if(attrs != null)
			{
				for(int i = 0; i < attrs.getLength(); i++)
				{
//					System.out.println(attrs.getQName(i) + ": " + attrs.getValue(i));
					ParamHelper.set(current, attrs.getQName(i), attrs.getValue(i));
				}
			}

		} catch (Exception e)
		{
			e.printStackTrace();

			System.out.println("class " + el + " not found.");
			System.exit(0);
		}

	}

	public void endElement(String namespaceURI,
		String sName, // simple name (localName)
		String qName) // qualified name
  throws SAXException
	{
		Object result = ((XmlSettable)current).initialize();
		current = objectStack.pop();

		if(current != null)
			ParamHelper.attach(current, result);
	}

}

