package pl.webnet.JaTrac;

import java.util.*;

final class NaiveTester extends IntersectionTester implements XmlSettable
{
	Scene scene;

	public void initialize(Scene scene, Camera cam)
	{
		this.scene = scene;
	}

	public int intersectRay(Ray ray)
	{
		return intersect(ray, scene.rootNode, 0, false);
	}

	public int intersectShadowfeeler(Ray ray)
	{
		return intersect(ray, scene.rootNode, 0, true);
	}

	public int intersect(Ray ray, Level level, int hits, boolean shadow)
	{
		for(Iterator i = level.children.iterator(); i.hasNext(); )
		{
			TreeNode tn = (TreeNode)i.next();
			
			if(tn instanceof Level)
			{
				hits += intersect(ray, (Level)tn, hits, shadow);
			}
			else
			{
				if((shadow && ((Primitive)tn).castShadows == true) ||
					(!shadow && (ray.generation == 0 || ((Primitive)tn).reflected == true)))
					hits += ((Primitive)tn).intersect(ray);
			}
		}

		return hits;
	}

	public Object initialize()
	{
		return this;
	}

	public String[] getParamArray()
	{
		final String params[] = {
		};

		return params;
	}

	public String[] getAttachArray()
	{
		String params[] = {
		};

		return params;
	}


}
	
