package pl.webnet.JaTrac;

import java.awt.*;

class Pixel
{
	static public final int RANGE_8BIT = 255;

	double r, g, b, a;
	Ray ray;
	int rayCount;
	int rayDepth;
	int AARays;
	
	public Pixel(double r, double g, double b)
	{
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = 0;
	}

	public Pixel()
	{
		r = g = b = a = 0;
	}

	public Pixel(Spectrum s)
	{
		set(s);
	}

	public void set(Spectrum s)
	{
		double[] components;
		components = s.getRGB(null);
		
		this.r = components[0];
		this.g = components[1];
		this.b = components[2];
		this.a = 0;
	}

	public int getRGB()
	{
		return ((int)(Math.min(1, r) * RANGE_8BIT) << 16) + ((int)(Math.min(1, g) * RANGE_8BIT) << 8) + ((int)(Math.min(1, b) * RANGE_8BIT));
	}

	public int getPreditheredRGB()
	{
		return((int)(r >= 1 ? RANGE_8BIT : RANGE_8BIT * r + Math.random()) << 16 |
						(int)(g >= 1 ? RANGE_8BIT : RANGE_8BIT * g + Math.random()) << 8 |
						(int)(b >= 1 ? RANGE_8BIT : RANGE_8BIT * b + Math.random()));
	}
}
