package pl.webnet.JaTrac;

import java.awt.image.*;

class Screen implements XmlSettable
{
	Pixel[][] pixels;
	protected int width, height;
	double AAThreshold = 0.1; // > 1 means no additional rays except for first 2
	boolean antialias = false;
	boolean shadows = true;
	String tBufferFilename;

	public Screen()
	{
	}

	public Screen(int width, int height)
	{
		this.width = width;
		this.height = height;
	}

	public void init()
	{
		pixels = new Pixel[height][width];
/*
		for(int y = 0; y < height; y++)
			for(int x = 0; x < width; x++)
			{
				pixels[y][x] = new Pixel(0., 0., 0.);
			}
*/
	}

	public String[] getParamArray()
	{
		String params[] = {
			"width", "width", "",
			"height", "height", "",
			"aathreshold", "AAThreshold", "",
			"antialias", "antialias", "",
			"tbuffer", "tBufferFilename", "",
			"shadows", "shadows", ""
		};

		return params;
	}

	public String[] getAttachArray() { return null; }
	
	public Object initialize()
	{
		if(antialias)
		{
			if(tBufferFilename != null)
			{
				System.out.println("Saving t-buffer for antialiased image is not possible. Disabling t-buffer");
				tBufferFilename = null;
			}
		}
		
		return this;
	}

	public int getWidth()
	{
		return width;
	}
	
	public int getHeight()
	{
		return height;
	}
	
	public BufferedImage toImage()
	{
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);

		for(int y = 0; y < height; y++)
			for(int x = 0; x < width; x++)
			{
				//bi.setRGB(x, y, pixels[y][x].getPreditheredRGB());
				bi.setRGB(x, y, pixels[y][x].getRGB());
			}

		return bi;
	}
}
